/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/

package cdac.medinfo.sdk.dcm30_04.templates.generaltemplates;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_BaselineCategory;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_Unit;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_Unit;

/**
 * This class represents ImageLibraryEntryDescriptorsForProjectionRadiography_TID1603
 */
public class ImageLibraryEntryDescriptorsForProjectionRadiography_TID1603 extends Template{

	
	/**
	 * Instantiates ImageLibraryEntryDescriptorsForProjectionRadiography_TID1603 Template.
	 * @param objTree Object of SRTree.
	 */
	public ImageLibraryEntryDescriptorsForProjectionRadiography_TID1603(SRTree objTree)
	{
		super(objTree); 
	}
	public void setImageView(int[] arrPosition, EnumCM_BaselineCategory enumBaselineCategory)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.IMAGE_VIEW.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.IMAGE_VIEW_111031.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();

		
		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSDesg, "", "", "", "");
		getSRTree().addChild(objContentSequenceItem);
	}
	public void setImageViewModifier(int[] arrPosition, EnumCM_BaselineCategory enumBaselineCategory)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.IMAGE_VIEW_MODIFIER.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.IMAGE_VIEW_MODIFIER_111032.getValue();
		String strCSDesg = EnumCodingSchemeDesignator.DCM.getValue();

		
		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning, strCodeValue, strCSDesg, "", "", "", "");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for HorizontalPixel Spacing
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue String array for Numeric Value.
	 */
	public void setHorizontalPixelSpacing(int[] arrPosition,String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCMForUnit = EnumCM_Unit.MM.getValue();
		String strCVForUnit = EnumCV_Unit.MM.getValue();
		String strCSDForUnit = EnumCodingSchemeDesignator.UCUM.getValue();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.HORIZONTAL_PIXEL_SPACING.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.HORIZONTAL_PIXEL_SPACING_111026.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition,strCodeMeaning,strCodeValue,strCSD,arrNumericValue,strCVForUnit,strCSDForUnit,"",strCMForUnit,"","","","");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for VerticalPixel Spacing
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue String array for Numeric Value.
	 */
	public void setVerticalPixelSpacing(int[] arrPosition,String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCMForUnit = EnumCM_Unit.MM.getValue();
		String strCVForUnit = EnumCV_Unit.MM.getValue();
		String strCSDForUnit = EnumCodingSchemeDesignator.UCUM.getValue();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.VERTICAL_PIXEL_SPACING.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.VERTICAL_PIXEL_SPACING_111066.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition,strCodeMeaning,strCodeValue,strCSD,arrNumericValue,strCVForUnit,strCSDForUnit,"",strCMForUnit,"","","","");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for PositionerPrimary Angle 
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue String array for Numeric Value.
	 */
	public void setPositionerPrimaryAngle(int[] arrPosition,String[] arrNumericValue)
	{
	

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.POSITIONER_PRIMARY_ANGLE.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.POSITIONER_PRIMARY_ANGLE_112011.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition,strCodeMeaning,strCodeValue,strCSD,arrNumericValue,"","","","","","","","");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for PositionerSecondary Angle 
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue String array for Numeric Value.
	 */
	public void setPositionerSecondaryAngle(int[] arrPosition,String[] arrNumericValue)
	{
	

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.POSITIONER_SECONDARY_ANGLE.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.POSITIONER_SECONDARY_ANGLE_112012.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition,strCodeMeaning,strCodeValue,strCSD,arrNumericValue,"","","","","","","","");
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for PatientOrientation Row
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strMeasurementMethod String value for Comment.
	 */
	public void setPatientOrientationRow(int[] arrPosition, String strPatientOrientation)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.PATIENT_ORIENTATION_ROW.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.PATIENT_ORIENTATION_ROW_111044.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strPatientOrientation);
		getSRTree().addChild(objContentSequenceItem);
	}
	/**
	 * Sets the value for PatientOrientation Column
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strMeasurementMethod String value for Comment.
	 */
	public void setPatientOrientationColumn(int[] arrPosition, String strPatientOrientation)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_ImageLibraryEntryDescriptorsForProjectionRadiography.PATIENT_ORIENTATION_COLUMN.getValue();
		String strCodeValue = EnumCV_ImageLibraryEntryDescriptorsForProjectionRadiography.PATIENT_ORIENTATION_COLUMN_111043.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strPatientOrientation);
		getSRTree().addChild(objContentSequenceItem);
	}
}
